Index: java/main/src/main/java/com/framsticks/communication/ClientConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientConnection.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/ClientConnection.java	(revision 85)
@@ -21,4 +21,5 @@
 import java.util.regex.Matcher;
 import java.util.regex.Pattern;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
@@ -29,5 +30,5 @@
 	private final static Logger log = Logger.getLogger(ClientConnection.class);
 
-	protected final Map<String, Subscription> subscriptions = new HashMap<String, Subscription>();
+	protected final Map<String, Subscription<?>> subscriptions = new HashMap<>();
 
 	public String getAddress() {
@@ -93,7 +94,7 @@
 
 	private static class EventFire extends InboundMessage {
-		public final Subscription subscription;
-
-		private EventFire(Subscription subscription) {
+		public final Subscription<?> subscription;
+
+		private EventFire(Subscription<?> subscription) {
 			this.subscription = subscription;
 		}
@@ -107,17 +108,13 @@
 		public void eof() {
 			finishCurrentFile();
-			Dispatching.invokeLaterOrNow(subscription.getDispatcher(), new Runnable() {
-				@Override
-				public void run() {
-					subscription.getEventCallback().call(getFiles());
-				}
-			});
-		}
-	}
-
-	private static class SentQuery extends InboundMessage {
+
+			subscription.dispatchCall(getFiles());
+		}
+	}
+
+	private static class SentQuery<C> extends InboundMessage {
 		Request request;
-		ResponseCallback callback;
-		Dispatcher dispatcher;
+		ResponseCallback<? extends C> callback;
+		Dispatcher<C> dispatcher;
 
 		public void startFile(String path) {
@@ -139,6 +136,15 @@
 			return request.toString();
 		}
-	}
-	private Map<Integer, SentQuery> queryMap = new HashMap<Integer, SentQuery>();
+
+		public void dispatchResponseProcess(final Response response) {
+			Dispatching.invokeLaterOrNow(dispatcher, new RunAt<C>() {
+				@Override
+				public void run() {
+					callback.process(response);
+				}
+			});
+		}
+	}
+	private Map<Integer, SentQuery<?>> queryMap = new HashMap<>();
 
 
@@ -163,11 +169,13 @@
 	}
 
-	private SentQuery currentlySentQuery;
-
-	public void send(Request request, ResponseCallback callback) {
-		send(request, AtOnceDispatcher.instance, callback);
-	}
-
-	public void send(Request request, Dispatcher dispatcher, ResponseCallback callback) {
+	private SentQuery<?> currentlySentQuery;
+
+
+	public <C extends Connection> void send(Request request, ResponseCallback<C> callback) {
+		//TODO RunAt
+		send(request, AtOnceDispatcher.getInstance(), callback);
+	}
+
+	public <C> void send(Request request, Dispatcher<C> dispatcher, ResponseCallback<? extends C> callback) {
 
 		if (!isConnected()) {
@@ -175,12 +183,13 @@
 			return;
 		}
-		final SentQuery sentQuery = new SentQuery();
+		final SentQuery<C> sentQuery = new SentQuery<C>();
 		sentQuery.request = request;
 		sentQuery.callback = callback;
 		sentQuery.dispatcher = dispatcher;
 
-		senderThread.invokeLater(new Runnable(){
+		senderThread.invokeLater(new RunAt<Connection>(){
 			@Override
 			public void run() {
+				Integer id;
 				synchronized (ClientConnection.this) {
 
@@ -192,6 +201,12 @@
 						}
 					}
-				}
-				Integer id = stashQuery(sentQuery);
+					if (requestIdEnabled) {
+						queryMap.put(nextQueryId, sentQuery);
+						id = nextQueryId++;
+					} else {
+						currentlySentQuery = sentQuery;
+						id = null;
+					}
+				}
 				String command = sentQuery.request.getCommand();
 				StringBuilder message = new StringBuilder();
@@ -223,6 +238,6 @@
 	}
 
-	public void subscribe(final String path, final SubscriptionCallback callback) {
-		send(new RegistrationRequest().setPath(path), new ResponseCallback() {
+	public <C> void subscribe(final String path, final Dispatcher<C> dispatcher, final SubscriptionCallback<? extends C> callback) {
+		send(new RegistrationRequest().path(path), new ResponseCallback<Connection>() {
 			@Override
 			public void process(Response response) {
@@ -233,5 +248,5 @@
 				}
 				assert response.getFiles().isEmpty();
-				Subscription subscription = new Subscription(ClientConnection.this, path, response.getComment());
+				Subscription<C> subscription = new Subscription<C>(ClientConnection.this, path, response.getComment(), dispatcher);
 				log.debug("registered on event: " + subscription);
 				synchronized (subscriptions) {
@@ -241,5 +256,5 @@
 				if (subscription.getEventCallback() == null) {
 					log.info("subscription for " + path + " aborted");
-					subscription.unsubscribe(new LoggingStateCallback(log, "abort subscription"));
+					subscription.unsubscribe(new LoggingStateCallback<C>(log, "abort subscription"));
 				}
 			}
@@ -253,5 +268,5 @@
 
 	public void sendQueryVersion(final int version, final StateFunctor stateFunctor) {
-		send(new VersionRequest().version(version), new StateCallback() {
+		send(new VersionRequest().version(version), new StateCallback<Connection>() {
 			@Override
 			public void call(Exception e) {
@@ -266,5 +281,5 @@
 					return;
 				}
-				send(new UseRequest().feature("request_id"), new StateCallback() {
+				send(new UseRequest().feature("request_id"), new StateCallback<Connection>() {
 					@Override
 					public void call(Exception e) {
@@ -289,10 +304,10 @@
 
 
-	private synchronized SentQuery fetchQuery(Integer id, boolean remove) {
+	private synchronized SentQuery<?> fetchQuery(Integer id, boolean remove) {
 		if (id == null) {
 			if (requestIdEnabled) {
 				return null;
 			}
-			SentQuery result = currentlySentQuery;
+			SentQuery<?> result = currentlySentQuery;
 			if (remove) {
 				currentlySentQuery = null;
@@ -302,5 +317,5 @@
 		}
 		if (queryMap.containsKey(id)) {
-			SentQuery result = queryMap.get(id);
+			SentQuery<?> result = queryMap.get(id);
 			if (remove) {
 				queryMap.remove(id);
@@ -312,13 +327,4 @@
 
 	private int nextQueryId = 0;
-
-	private Integer stashQuery(SentQuery sentQuery) {
-		if (!requestIdEnabled) {
-			currentlySentQuery = sentQuery;
-			return null;
-		}
-		queryMap.put(nextQueryId, sentQuery);
-		return nextQueryId++;
-	}
 
 	protected void processMessage(InboundMessage inboundMessage) throws Exception {
@@ -342,5 +348,5 @@
 			return;
 		}
-		Subscription subscription = subscriptions.get(matcher.group(1));
+		Subscription<?> subscription = subscriptions.get(matcher.group(1));
 		if (subscription == null) {
 			log.error("non subscribed event: " + matcher.group(1));
@@ -362,5 +368,5 @@
 
 		if (command.first.equals("file")) {
-			SentQuery sentQuery = fetchQuery(rest.first, false);
+			SentQuery<?> sentQuery = fetchQuery(rest.first, false);
 			sentQuery.startFile(rest.second);
 			processMessage(sentQuery);
@@ -368,5 +374,5 @@
 		}
 
-		SentQuery sentQuery = fetchQuery(rest.first, true);
+		SentQuery<?> sentQuery = fetchQuery(rest.first, true);
 		if (sentQuery == null) {
 			return;
@@ -374,13 +380,5 @@
 		log.debug("parsing response for request " + sentQuery);
 
-		final Response response = new Response(command.first.equals("ok"), rest.second, sentQuery.getFiles());
-		final ResponseCallback callback = sentQuery.callback;
-
-		Dispatching.invokeLaterOrNow(sentQuery.dispatcher, new Runnable() {
-			@Override
-			public void run() {
-				callback.process(response);
-			}
-		});
+		sentQuery.dispatchResponseProcess(new Response(command.first.equals("ok"), rest.second, sentQuery.getFiles()));
 	}
 
Index: java/main/src/main/java/com/framsticks/communication/Connection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 85)
@@ -1,4 +1,5 @@
 package com.framsticks.communication;
 
+import com.framsticks.util.io.Encoding;
 import com.framsticks.util.lang.Pair;
 import org.apache.log4j.Logger;
@@ -6,10 +7,13 @@
 import java.io.IOException;
 import java.io.InputStreamReader;
+import java.io.OutputStreamWriter;
 import java.io.PrintWriter;
-import java.lang.Thread;
 import java.net.Socket;
 import java.net.SocketTimeoutException;
 import java.util.regex.Matcher;
 import java.util.regex.Pattern;
+
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.Thread;
 
 public abstract class Connection {
@@ -28,6 +32,6 @@
 	protected int protocolVersion = -1;
 
-	protected final com.framsticks.util.dispatching.Thread senderThread = new com.framsticks.util.dispatching.Thread();
-	protected Thread receiverThread;
+	protected final Thread<Connection> senderThread = new Thread<>();
+	protected final Thread<Connection> receiverThread = new Thread<>();
 
 	public boolean isConnected() {
@@ -42,9 +46,7 @@
 			senderThread.interrupt();
 			senderThread.join();
-			if (receiverThread != null) {
-				receiverThread.interrupt();
-				receiverThread.join();
-				receiverThread = null;
-			}
+
+			receiverThread.interrupt();
+			receiverThread.join();
 
 			if (output != null) {
@@ -72,7 +74,7 @@
 
 	protected static final String ARGUMENT_PATTERN_FRAGMENT = "((?:\\S+)|(?:\"[^\"]*\"))";
-	protected static Pattern requestIdEnabledPattern = Pattern.compile("^\\s*([0-9]+)(?:\\s+" + ARGUMENT_PATTERN_FRAGMENT + ")?\\n$");
-	protected static Pattern requestIDisabledPattern = Pattern.compile("^\\s*" + ARGUMENT_PATTERN_FRAGMENT + "?\\n$");
-	protected static Pattern eventPattern = Pattern.compile("^\\s*(\\S+)\\s*(\\S+)\\n");
+	protected static final Pattern requestIdEnabledPattern = Pattern.compile("^\\s*([0-9]+)(?:\\s+" + ARGUMENT_PATTERN_FRAGMENT + ")?\\n$");
+	protected static final Pattern requestIDisabledPattern = Pattern.compile("^\\s*" + ARGUMENT_PATTERN_FRAGMENT + "?\\n$");
+	protected static final Pattern eventPattern = Pattern.compile("^\\s*(\\S+)\\s*(\\S+)\\n");
 
 
@@ -126,6 +128,6 @@
 	protected void runThreads() {
 		try {
-			output = new PrintWriter(socket.getOutputStream(), true);
-			input = new BufferedReader(new InputStreamReader(socket.getInputStream()));
+			output = new PrintWriter(new OutputStreamWriter(socket.getOutputStream(), Encoding.getFramsticksCharset()), true);
+			input = new BufferedReader(new InputStreamReader(socket.getInputStream(), Encoding.getFramsticksCharset()));
 		} catch (IOException e) {
 			log.error("buffer creation failure");
@@ -135,5 +137,10 @@
 
 		senderThread.setName(this + "-sender");
-		receiverThread = new Thread(new Runnable() {
+		receiverThread.setName(this + "-receiver");
+
+		senderThread.start();
+		receiverThread.start();
+
+		receiverThread.invokeLater(new RunAt<Connection>() {
 			@Override
 			public void run() {
@@ -148,8 +155,5 @@
 			}
 		});
-		receiverThread.setName(this + "-receiver");
 
-		senderThread.start();
-		receiverThread.start();
 	}
 
Index: java/main/src/main/java/com/framsticks/communication/RequestHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/RequestHandler.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/RequestHandler.java	(revision 85)
@@ -7,4 +7,4 @@
  */
 public interface RequestHandler {
-    public void handle(ApplicationRequest request, ResponseCallback responseCallback);
+	public void handle(ApplicationRequest request, ResponseCallback<?> responseCallback);
 }
Index: java/main/src/main/java/com/framsticks/communication/ResponseCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ResponseCallback.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/ResponseCallback.java	(revision 85)
@@ -4,5 +4,5 @@
  * @author Piotr Sniegowski
  */
-public interface ResponseCallback {
+public interface ResponseCallback<C> {
 	public void process(Response response);
 }
Index: java/main/src/main/java/com/framsticks/communication/ServerConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerConnection.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/ServerConnection.java	(revision 85)
@@ -8,4 +8,5 @@
 
 import java.net.Socket;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
@@ -26,6 +27,4 @@
 
 	public void start() {
-
-
 		runThreads();
 	}
@@ -43,7 +42,7 @@
 	}
 
-	protected void handleRequest(Request request, ResponseCallback responseCallback) {
+	protected void handleRequest(Request request, ResponseCallback<?> responseCallback) {
 		if (request instanceof ApplicationRequest) {
-			requestHandler.handle((ApplicationRequest)request, responseCallback);
+			requestHandler.handle((ApplicationRequest) request, responseCallback);
 			return;
 		}
@@ -70,5 +69,5 @@
 
 	protected final void respond(final Response response, final Integer id) {
-		senderThread.invokeLater(new Runnable() {
+		senderThread.invokeLater(new RunAt<Connection>() {
 			@Override
 			public void run() {
@@ -118,5 +117,5 @@
 		}
 
-		handleRequest(request, new ResponseCallback() {
+		handleRequest(request, new ResponseCallback<ServerConnection>() {
 			@Override
 			public void process(Response response) {
Index: java/main/src/main/java/com/framsticks/communication/StateCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/StateCallback.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/StateCallback.java	(revision 85)
@@ -6,5 +6,5 @@
  * @author Piotr Sniegowski
  */
-public abstract class StateCallback implements ResponseCallback, StateFunctor {
+public abstract class StateCallback<C> implements ResponseCallback<C>, StateFunctor {
 	@Override
 	public void process(Response response) {
Index: java/main/src/main/java/com/framsticks/communication/Subscription.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 85)
@@ -1,7 +1,10 @@
 package com.framsticks.communication;
 
+import java.util.List;
+
 import com.framsticks.communication.queries.RegistrationRequest;
-import com.framsticks.util.dispatching.AtOnceDispatcher;
 import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.StateFunctor;
 import org.apache.log4j.Logger;
@@ -11,19 +14,20 @@
  * @author Piotr Sniegowski
  */
-public class Subscription {
+public class Subscription<C> {
 
-    private final static Logger log = Logger.getLogger(Subscription.class);
+	private final static Logger log = Logger.getLogger(Subscription.class);
 
-    private final ClientConnection connection;
-    private final String path;
+	private final ClientConnection connection;
+	private final String path;
 	private final String registeredPath;
-    private Dispatcher dispatcher = AtOnceDispatcher.instance;
+	private final Dispatcher<C> dispatcher;
 
 	private EventCallback eventCallback;
 
-	public Subscription(ClientConnection connection, String path, String registeredPath) {
+	public Subscription(ClientConnection connection, String path, String registeredPath, Dispatcher<C> dispatcher) {
 		this.connection = connection;
-        this.path = path;
+		this.path = path;
 		this.registeredPath = registeredPath;
+		this.dispatcher = dispatcher;
 	}
 
@@ -41,35 +45,40 @@
 	}
 
-    public void setDispatcher(Dispatcher dispatcher) {
-        this.dispatcher = dispatcher;
-    }
+	public void unsubscribe(final StateFunctor stateFunctor) {
+		//@todo remove that /cli/ prefix, when registeredPath will be a fully qualified path
+		connection.send(new RegistrationRequest().register(false).path(registeredPath), new ResponseCallback<Connection>() {
+			@Override
+			public void process(Response response) {
+				if (!response.getOk()) {
+					log.error("failed to unsunscribe " + this + ": " + response.getComment());
+					stateFunctor.call(new Exception(response.getComment()));
+					return;
+				}
+				assert response.hasFiles();
+				log.debug("unsunscribed " + this);
+				stateFunctor.call(null);
+			}
+		});
+	}
 
-    public void unsubscribe(final StateFunctor stateFunctor) {
-        //@todo remove that /cli/ prefix, when registeredPath will be a fully qualified path
-        connection.send(new RegistrationRequest().register(false).setPath(registeredPath), new ResponseCallback() {
-            @Override
-            public void process(Response response) {
-                if (!response.getOk()) {
-                    log.error("failed to unsunscribe " + this + ": " + response.getComment());
-                    stateFunctor.call(new Exception(response.getComment()));
-                    return;
-                }
-                assert response.hasFiles();
-                log.debug("unsunscribed " + this);
-                stateFunctor.call(null);
-            }
-        });
-    }
+	public EventCallback getEventCallback() {
+		return eventCallback;
+	}
 
-    public EventCallback getEventCallback() {
-        return eventCallback;
-    }
+	public Dispatcher<C> getDispatcher() {
+		return dispatcher;
+	}
 
-    public Dispatcher getDispatcher() {
-        return dispatcher;
-    }
+	public void setEventCallback(EventCallback eventCallback) {
+		this.eventCallback = eventCallback;
+	}
 
-    public void setEventCallback(EventCallback eventCallback) {
-        this.eventCallback = eventCallback;
-    }
+	public void dispatchCall(final List<File> files) {
+		Dispatching.invokeLaterOrNow(dispatcher, new RunAt<C>() {
+			@Override
+			public void run() {
+				eventCallback.call(files);
+			}
+		});
+	}
 }
Index: java/main/src/main/java/com/framsticks/communication/SubscriptionCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/SubscriptionCallback.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/SubscriptionCallback.java	(revision 85)
@@ -4,5 +4,5 @@
  * @author Piotr Sniegowski
  */
-public interface SubscriptionCallback {
-	EventCallback subscribed(Subscription subscription);
+public interface SubscriptionCallback<C> {
+	EventCallback subscribed(Subscription<? super C> subscription);
 }
Index: java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java	(revision 85)
@@ -14,5 +14,5 @@
 	protected String fields;
 
-	public ApplicationRequest setPath(String path) {
+	public ApplicationRequest path(String path) {
 		assert path != null;
 		this.path = path;
@@ -20,15 +20,15 @@
 	}
 
-	public ApplicationRequest setField(String field) {
+	public ApplicationRequest field(String field) {
 		this.fields = field;
 		return this;
 	}
 
-	public ApplicationRequest setFields(Collection<String> fields) {
+	public ApplicationRequest fields(Collection<String> fields) {
 		Delimeted d = new Delimeted(",", "");
 		for (String f : fields) {
 			d.append(f);
 		}
-		return setField(d.build());
+		return field(d.build());
 	}
 
Index: java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java	(revision 85)
@@ -7,5 +7,5 @@
  * @author Piotr Sniegowski
  */
-public class LoggingStateCallback extends StateCallback {
+public class LoggingStateCallback<C> extends StateCallback<C> {
 
 	protected final Logger logger;
@@ -23,5 +23,5 @@
 			return;
 		}
-        logger.debug(message);
+		logger.debug(message);
 	}
 }
Index: java/main/src/main/java/com/framsticks/communication/util/LoggingSubscriptionCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/util/LoggingSubscriptionCallback.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/communication/util/LoggingSubscriptionCallback.java	(revision 85)
@@ -9,24 +9,24 @@
  * @author Piotr Sniegowski
  */
-public class LoggingSubscriptionCallback implements SubscriptionCallback {
+public class LoggingSubscriptionCallback<C> implements SubscriptionCallback<C> {
 
-    protected final Logger logger;
-    protected final String message;
-    private final EventCallback eventCallback;
+	protected final Logger logger;
+	protected final String message;
+	private final EventCallback eventCallback;
 
-    public LoggingSubscriptionCallback(Logger logger, String message, EventCallback eventCallback) {
-        this.logger = logger;
-        this.message = message;
-        this.eventCallback = eventCallback;
-    }
+	public LoggingSubscriptionCallback(Logger logger, String message, EventCallback eventCallback) {
+		this.logger = logger;
+		this.message = message;
+		this.eventCallback = eventCallback;
+	}
 
-    @Override
-    public EventCallback subscribed(Subscription subscription) {
-        if (subscription == null) {
-            logger.error("failed to subscribe for " + message);
-            return null;
-        }
-        logger.info("successfuly subscribed for " + message);
-        return eventCallback;
-    }
+	@Override
+	public EventCallback subscribed(Subscription<? super C> subscription) {
+		if (subscription == null) {
+			logger.error("failed to subscribe for " + message);
+			return null;
+		}
+		logger.info("successfuly subscribed for " + message);
+		return eventCallback;
+	}
 }
Index: java/main/src/main/java/com/framsticks/core/Entity.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Entity.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/core/Entity.java	(revision 85)
@@ -1,3 +1,5 @@
 package com.framsticks.core;
+
+import javax.annotation.OverridingMethodsMustInvokeSuper;
 
 import com.framsticks.params.FramsClass;
@@ -7,9 +9,10 @@
 import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
  * @author Piotr Sniegowski
  */
-public abstract class Entity implements Dispatcher {
+public abstract class Entity implements Dispatcher<Entity> {
 
 	private final static Logger log = Logger.getLogger(Entity.class.getName());
@@ -17,5 +20,5 @@
 	protected String name = "entity";
 	protected EntityOwner owner;
-	protected Dispatcher dispatcher;
+	protected Dispatcher<Entity> dispatcher;
 
 	public Entity() {
@@ -32,5 +35,5 @@
 		this.name = name;
 		if (dispatcher instanceof Thread) {
-			((Thread) dispatcher).setName(name);
+			((Thread<Entity>) dispatcher).setName(name);
 		}
 	}
@@ -56,13 +59,14 @@
 
 	@Override
-	public final void invokeLater(Runnable runnable) {
+	public final void invokeLater(RunAt<? extends Entity> runnable) {
 		assert dispatcher != null;
 		dispatcher.invokeLater(runnable);
 	}
 
-	public Dispatcher createDefaultDispatcher() {
-		return new Thread(name);
+	public Dispatcher<Entity> createDefaultDispatcher() {
+		return new Thread<Entity>(name).start();
 	}
 
+	@OverridingMethodsMustInvokeSuper
 	protected void run() {
 		assert isActive();
@@ -74,5 +78,5 @@
 	}
 
-	public Dispatcher getDispatcher() {
+	public Dispatcher<Entity> getDispatcher() {
 		return dispatcher;
 	}
@@ -81,5 +85,5 @@
 	 * @param dispatcher the dispatcher to set
 	 */
-	public void setDispatcher(Dispatcher dispatcher) {
+	public void setDispatcher(Dispatcher<Entity> dispatcher) {
 		this.dispatcher = dispatcher;
 	}
@@ -90,5 +94,5 @@
 			setDispatcher(createDefaultDispatcher());
 		}
-		invokeLater(new Runnable() {
+		invokeLater(new RunAt<Entity>() {
 			@Override
 			public void run() {
Index: java/main/src/main/java/com/framsticks/core/Instance.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Instance.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/core/Instance.java	(revision 85)
@@ -12,4 +12,5 @@
 import com.framsticks.util.lang.Casting;
 import org.apache.log4j.Logger;
+import com.framsticks.util.dispatching.RunAt;
 
 import java.util.*;
@@ -33,5 +34,5 @@
 	protected void run() {
 		super.run();
-		root = new Node((CompositeParam)new ParamBuilder().setName("Instance").setId(name).setType("o").build(), null);
+		root = new Node((CompositeParam)Param.build().name("Instance").id(name).type("o").finish(), null);
 		com.framsticks.model.Package.register(registry);
 	}
@@ -71,5 +72,5 @@
 	public void storeValue(Path path, Param param, Object value, final StateFunctor stateFunctor) {
 		assert isActive();
-		invokeLater(new Runnable() {
+		invokeLater(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -93,5 +94,5 @@
 	public void addListener(final InstanceListener listener) {
 		assert Dispatching.isThreadSafe();
-		Dispatching.invokeLaterOrNow(this, new Runnable() {
+		Dispatching.invokeLaterOrNow(this, new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -103,5 +104,5 @@
 	public void removeListener(final InstanceListener listener) {
 		assert Dispatching.isThreadSafe();
-		Dispatching.invokeLaterOrNow(this, new Runnable() {
+		Dispatching.invokeLaterOrNow(this, new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -271,5 +272,5 @@
 		if ("/".equals(file.getPath())) {
 			if (root.getParam().getContainedTypeName() == null) {
-				root = new Node((CompositeParam)new ParamBuilder().setName("Instance").setId(name).setType("o " + framsClass.getId()).build(), root.getObject());
+				root = new Node((CompositeParam)Param.build().name("Instance").id(name).type("o " + framsClass.getId()).finish(), root.getObject());
 			}
 		}
@@ -310,5 +311,5 @@
 
 					String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
-					Param param = new ParamBuilder().setType("o " + accessInterface.getId()).setId(id).build();
+					Param param = Param.build().type("o " + accessInterface.getId()).id(id).finish();
 					Object child = accessInterface.getSelected();
 					accessInterface.select(null);
Index: java/main/src/main/java/com/framsticks/core/ListChange.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/ListChange.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/core/ListChange.java	(revision 85)
@@ -2,5 +2,5 @@
 
 import com.framsticks.params.FramsClass;
-import com.framsticks.params.ParamBuilder;
+import com.framsticks.params.Param;
 import com.framsticks.params.types.DecimalParam;
 import com.framsticks.params.types.EnumParam;
@@ -55,7 +55,7 @@
 	public static FramsClass getFramsClass() {
 		return new FramsClass("ListChange", "ListChange", null)
-				.append(new ParamBuilder().setId("type").setName("type").setType(new EnumParam(Arrays.asList("Add", "Remove", "Modify"))).build())
-				.append(new ParamBuilder().setId("id").setName("identifier").setType(StringParam.class).build())
-				.append(new ParamBuilder().setId("pos").setName("position").setType(DecimalParam.class).build());
+				.append(Param.build().id("type").name("type").type(new EnumParam(Arrays.asList("Add", "Remove", "Modify"))))
+				.append(Param.build().id("id").name("identifier").type(StringParam.class))
+				.append(Param.build().id("pos").name("position").type(DecimalParam.class));
 	}
 
Index: java/main/src/main/java/com/framsticks/core/LocalInstance.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/LocalInstance.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/core/LocalInstance.java	(revision 85)
@@ -13,4 +13,5 @@
 import java.util.HashSet;
 import java.util.Set;
+import com.framsticks.util.dispatching.RunAt;
 
 
@@ -33,5 +34,5 @@
 				acceptSocket = new ServerSocket();
 				acceptSocket.setReuseAddress(true);
-				acceptThread = new Thread(name + "-accept");
+				acceptThread = new Thread<Accept>(name + "-accept").start();
 				tryBind(accept);
 			} catch (IOException e) {
@@ -43,8 +44,12 @@
 	protected final Set<InstanceClient> clients = new HashSet<InstanceClient>();
 	ServerSocket acceptSocket;
-	Thread acceptThread;
+
+	public static class Accept {
+	};
+
+	Thread<Accept> acceptThread;
 
 	protected void acceptNext() {
-		acceptThread.invokeLater(new Runnable() {
+		acceptThread.invokeLater(new RunAt<Accept>() {
 			@Override
 			public void run() {
@@ -53,5 +58,5 @@
 					assert socket != null;
 					log.debug("accepted socket: " + socket.getInetAddress().getHostAddress());
-					invokeLater(new Runnable() {
+					invokeLater(new RunAt<LocalInstance>() {
 						@Override
 						public void run() {
@@ -70,5 +75,5 @@
 
 	public void tryBind(final Integer accept) {
-		acceptThread.invokeLater(new Runnable() {
+		acceptThread.invokeLater(new RunAt<Accept>() {
 			@Override
 			public void run() {
Index: java/main/src/main/java/com/framsticks/core/Path.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Path.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/core/Path.java	(revision 85)
@@ -5,8 +5,12 @@
 import com.framsticks.params.Param;
 import com.framsticks.util.dispatching.Dispatching;
+
 import java.util.Iterator;
 import java.util.LinkedList;
 import java.util.List;
 
+import javax.annotation.concurrent.Immutable;
+import javax.annotation.Nonnull;
+
 import org.apache.commons.collections.ListUtils;
 
@@ -14,4 +18,5 @@
  * @author Piotr Sniegowski
  */
+@Immutable
 public class Path {
 	// private final static Logger log = Logger.getLogger(Path.class.getName());
@@ -63,5 +68,5 @@
 	}
 
-	public Path(Instance instance, List<Node> nodes, Node node) {
+	public Path(@Nonnull Instance instance, List<Node> nodes, Node node) {
 		this.instance = instance;
 		StringBuilder b = new StringBuilder();
@@ -196,4 +201,8 @@
 	}
 
+	public void setInstance(Instance instance) {
+		this.instance = instance;
+	}
+
 	@SuppressWarnings("unchecked")
 	public
Index: java/main/src/main/java/com/framsticks/core/Program.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Program.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/core/Program.java	(revision 85)
@@ -10,9 +10,10 @@
 import java.lang.reflect.Constructor;
 import java.util.*;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
  * @author Piotr Sniegowski
  */
-public class Program extends com.framsticks.util.dispatching.Thread {
+public class Program extends com.framsticks.util.dispatching.Thread<Program> {
 
 	private final static Logger log = Logger.getLogger(Program.class.getName());
@@ -101,5 +102,5 @@
 
 		final Program program = new Program("program");
-		program.invokeLater(new Runnable() {
+		program.invokeLater(new RunAt<Program>() {
 			@Override
 			public void run() {
